#include "Python.h"
#include <stdio.h>
#include <stdlib.h>

/*
 * stats module interface
 */

static PyObject *ErrorObject;

PyObject *pqueue_new(PyObject *self, PyObject *args);
PyObject *icfp_board(PyObject *self, PyObject *args);

static PyObject *
heur1(PyObject *self, PyObject *args)
{
  PyObject *tup1;
  PyObject *tup2;

  if (!PyArg_ParseTuple(args, "O!O!", &PyTuple_Type, &tup1, &PyTuple_Type, &tup2)) {
    return NULL;
  }
  return PyInt_FromLong((labs(PyInt_AsLong(PyTuple_GET_ITEM(tup1,0)) -
			      PyInt_AsLong(PyTuple_GET_ITEM(tup2,0))))
			+
			(labs(PyInt_AsLong(PyTuple_GET_ITEM(tup1,1)) -
			      PyInt_AsLong(PyTuple_GET_ITEM(tup2,1))))
			);
}


static PyMethodDef stats_methods[] = {
        {"PQueue",  pqueue_new,      METH_VARARGS},
	{"Board", icfp_board, METH_VARARGS},
	{"heuristic1", heur1, METH_VARARGS},
	//{"Combination",  stats_combination,      METH_VARARGS},
        //        {"Cartesian",    stats_cartesian,        METH_VARARGS},
	{NULL,		NULL}		/* sentinel */
};

/* Initialization function for the module (*must* be called initxx) */

DL_EXPORT(void)
initicfp(void)
{
	PyObject *m, *d;
	/* Create the module and add the functions */
	m = Py_InitModule("icfp", stats_methods);

	/* Add some symbolic constants to the module */
	d = PyModule_GetDict(m);
	ErrorObject = PyErr_NewException("icfp.error", NULL, NULL);
	PyDict_SetItemString(d, "error", ErrorObject);
}
